from vcHelpers.Application import *

app = getApplication()

def SelectMode(args):
  if mode.Value == "Comp-Comp":
    component1.IsVisible = True
    component2.IsVisible = True
    component1Node.IsVisible = False
    component2Node.IsVisible = False
  if mode.Value == "Comp-Node":
    component1.IsVisible = True
    component2Node.IsVisible = True
    component2.IsVisible = False
    component1Node.IsVisible = False
  if mode.Value == "Node-Node":
    component1Node.IsVisible = True
    component2Node.IsVisible = True
    component1.IsVisible = False
    component2.IsVisible = False

def MeasureDistance(args):
  if mode.Value == "Comp-Comp" and component1.Value != None and component2.Value != None:
    a = app.findComponent(component1.Value.Name)
    b = app.findComponent(component2.Value.Name)
    return_tuple = a.measureDistance(a, b)
  if mode.Value == "Comp-Node" and component1.Value != None and component2Node.Value != None:
    a = app.findComponent(component1.Value.Name)
    b = app.findComponent(component2Node.Value.Component.Name)
    d = b.findNode(component2Node.Value.Name)
    return_tuple = a.measureDistance(a, d)
  if mode.Value == "Node-Node" and component1Node.Value != None and component2Node.Value != None:
    a = app.findComponent(component1Node.Value.Component.Name)
    b = app.findComponent(component2Node.Value.Component.Name)
    c = a.findNode(component1Node.Value.Name)
    d = b.findNode(component2Node.Value.Name)
    return_tuple = c.measureDistance(c, d)
  print "MinDistance:",return_tuple[0],"mm"

def OnStart():
  global diag, mode, component1, component1Node, component2, component2Node
  
  diag = getDialog("MeasureMin")
  mode = diag.addProperty("Mode",VC_STRING,SelectMode,VC_PROPERTY_STEP)
  mode.StepValues = ["Comp-Comp","Comp-Node","Node-Node"]
  component1 = diag.addProperty("Component1","Ref<Component>")
  component1Node = diag.addProperty("Component1Node","Ref<Node>")
  component2 = diag.addProperty("Component2","Ref<Component>")
  component2Node = diag.addProperty("Component2Node","Ref<Node>")
  measure = diag.addProperty("MeasureMinDistance",VC_BUTTON,MeasureDistance)
  
  component1.IsVisible = False
  component2.IsVisible = False
  component1Node.IsVisible = False
  component2Node.IsVisible = False
    
  diag.show()
  
